import java.io.*;
import java.net.*;
class UnexpectedSMTPCode extends Exception {
    String line;
    UnexpectedSMTPCode(String s) { this.line = s; }
    String getString() { return line; }
}
public class JMailer {
    static String smtp_host, local_host;
    static int port = 25;
    static String local_email, email;
    static String subject;
    static Socket s;
    static BufferedReader in;
    static BufferedReader local_in = 
	new BufferedReader(new InputStreamReader(System.in));
    static PrintStream out;
    static boolean debug = false;
    static void send(String line) {
	if(debug) System.out.println("SEND: "+line);
	out.println(line);
    }
    static void expect(int code) throws IOException, UnexpectedSMTPCode {
	String line = in.readLine();
	if(debug) System.out.println("RECEIVE: "+line);
	if(!line.startsWith(code+" ")) throw new UnexpectedSMTPCode(line);
    }
    static void read_and_send_body() throws IOException {
	System.out.println("Contenu du mail ?");
	for(String line = local_in.readLine(); line != null;
	    line = local_in.readLine()) {
	    if(line.startsWith(".")) out.print(".");
	    send(line);
	}
    }
    public static void main(String args[]) {
	if (args.length != 2) {
	    System.err.println("Usage: java JMailer <local_email> <email>");
	    System.exit(1);
	}
	try {
	    smtp_host = "nivose";
	    local_host = InetAddress.getLocalHost().getHostName();
	    port = 25;
	    local_email = args[0];
	    email = args[1];
	    s = new Socket(smtp_host, port);
	    in = new BufferedReader(new InputStreamReader(s.getInputStream()));
	    out = new PrintStream(s.getOutputStream());
	    expect(220);
	    send("HELO "+local_host);
	    expect(250);
	    send("MAIL FROM: "+local_email);
	    expect(250);
	    send("RCPT TO: "+email);
	    expect(250);
	    send("DATA");
	    expect(354);
	    send("From: "+local_email);
	    send("To: "+email);
	    System.out.println("Sujet du mail ?");
	    subject = local_in.readLine();
	    send("Subject: "+subject);
	    send("");
	    read_and_send_body();
	    send(".");
	    expect(250);
	    send("QUIT");
	    expect(221);
	    s.close();
	}
	catch (UnknownHostException e) {
	    System.err.println("*** Nom de machine inconnu : "+e.getMessage());
	    System.exit(2);
	}
	catch (IOException e) {
	    e.printStackTrace();
	    System.exit(3);
	}
	catch (UnexpectedSMTPCode e) {
	    System.err.print("*** Code de retour inattendu : ");
	    System.err.println(e.getString());
	    System.exit(4);
	}
    }
}