import java.io.*;
import java.net.*;
public class JWGet {
       public static void main(String args[])  {
	if (args.length != 1) {
	    System.err.println("Usage: java JWGet <url>");
	    System.exit(1);
	}
	String host = "cache";
	int port = 3128;
	try {
	    URL url = new URL(args[0]);
	    if(!url.getProtocol().equals("http")) {
		System.out.println("Je ne parle que le HTTP.");
		System.exit(5);
	    }
	    Socket s = new Socket(host, port);
	    BufferedReader in =
		new BufferedReader(new InputStreamReader(s.getInputStream()));
	    PrintStream out =
		new PrintStream(s.getOutputStream());
	    PrintStream file_out = 
		new PrintStream(new FileOutputStream("."+url.getFile()));
	    out.println("GET "+url);
	    for(String line = in.readLine();
		line != null;
		line = in.readLine()) {
		file_out.println(line);
	    }
	    file_out.close();
	    s.close();
	}
	catch (UnknownHostException e) {
	    System.err.println("Nom de machine inconnu : "+e.getMessage());
	    System.exit(2);
	}
	catch (MalformedURLException e) {
	    System.err.println("URL incompréhensible : "+e.getMessage());
	    System.exit(3);
	}
	catch (IOException e) {
	    e.printStackTrace();
	    System.exit(4);
	}
    }

}